#!/usr/bin/perl

# water.pl - convert tiff image to scaled jpeg image;
#            extract XML data from tiff image;
#            make HTML files from XML

# Eric Lease Morgan
# http://www.lib.ncsu.edu/staff/morgan/

# 3/26/01 - added URL and about link
# 3/20/01 - first cut


# define the location of tiffinfo; see http://www.libtiff.org/
$TIFFINFO = '/usr/bin/tiffinfo';

# define the convert command; see http://www.imagemagick.org/
$CONVERT = '/usr/X11R6/bin/convert -geometry 33%x33% ';

# define the xalan command; see http://xml.apache.org/
$XALAN = '/usr/bin/java -classpath /home/eric/srcs/xalan-j_2_0_0/bin/xalan.jar:/home/eric/srcs/xalan-j_2_0_0/bin/xerces.jar org.apache.xalan.xslt.Process -xsl water.xsl -in ';

# process input
for ($i = 0; $i <= $#ARGV; $i++) {

	# get the current filename
	$file = $ARGV[$i];
	
	# convert the file to a jpeg while scaling it 33%
	$cmd = $CONVERT . $file . '.tif ' . $file . '.jpeg';
	`$cmd`;

	# extract data from description tag
	$cmd = $TIFFINFO . ' ' . $file . '.tif';
	$xml = `$cmd`;

	# parse out the XML; watch out because description is not always in the 9th position
	@xml = split("\n", $xml);
	$xml = $xml[8];
	$xml =~ s/\\r//g;
	$xml =~ s/\\n/\n/g;
	$xml =~ s/  Image Description: "//g;
	$xml =~ s/$\"//g;

	# output xml
	open  XML, "> $file" . '.xml';
	print XML $xml;
	close XML;
	
	# convert XML to HTML
	$cmd = $XALAN . $file . '.xml';
	$html = `$cmd`;
	open  HTML, "> $file" . '.html';
	print HTML $html;
	close HTML;
	
}

# create browsable list
open HTML, "> water.html";
print HTML '<html><head><title>Water collection</title></head><body><h1>Water collection</h1><ul>';
for ($i=0; $i <=$#ARGV; $i++) {
	print HTML "<li><a href=$ARGV[$i]" . '.html' . '>' . $ARGV[$i] . '</a>';
}
print HTML '</ul><a href=./about.html>About these pages</a></body></html>';
close HTML;

